
DROP TABLE IF EXISTS p20_pdm.t01_ccc_ib_record;
CREATE TABLE IF NOT EXISTS p20_pdm.t01_ccc_ib_record (
	 ib_unique_id  varchar(50) 
	, call_id  varchar(50) 
	, customer_number  varchar(20) 
	, customer_number_encrypt  varchar(50) 
	, customer_province  varchar(20) 
	, customer_city  varchar(20) 
	, first_call_number  varchar(20) 
	, first_call_cno  varchar(20) 
	, first_call_cname  varchar(20) 
	, first_call_qno  varchar(20) 
	, first_call_qname  varchar(20) 
	, ivr_name  varchar(20) 
	, hotline  varchar(20) 
	, hotline_name  varchar(20) 
	, xnumber  varchar(20) 
	, ib_status  varchar(20) 
	, ib_result  varchar(20) 
	, status_robot  varchar(20) 
	, ib_tag  varchar(20) 
	, webrtc_call_id  varchar(50) 
	, sip_cause_desc  varchar(50) 
	, call_type  varchar(10) 
	, record_file  text 
	, on_hook_source  varchar(20) 
	, investigation_keys  varchar(20) 
	, agent_answer_in_time  varchar(20) 
	, evaluation  varchar(20) 
	, user_field  text 
	, start_time  timestamp(0) 
	, ring_time  timestamp(0) 
	, ib_ringing_duration  int 
	, end_time  timestamp(0) 
	, answer_time  timestamp(0) 
	, offhook_time  timestamp(0) 
	, bridge_time  timestamp(0) 
	, bridge_duration  int 
	, total_duration  int 
	, first_join_queue_time  timestamp(0) 
	, say_voice_duration  int 
	, mark_data  text 
	, Etl_First_Dt  timestamp(0) 
	, Etl_Job  varchar(200) 
	, Etl_Proc_Dt  timestamp(0) 
	, Etl_Tx_Dt  timestamp(0) 
	, Src_Sysname  varchar(50) 
	, Src_Table  varchar(50) 
	, Etl_Batch_No  varchar(50) 
	,primary key( ib_unique_id )
);

 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.ib_unique_id IS '呼入通话ID'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.call_id IS 'CallID'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.customer_number IS '客户号码'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.customer_number_encrypt IS '客户号码加密串'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.customer_province IS '客户省份'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.customer_city IS '客户城市'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.first_call_number IS '首呼座席电话'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.first_call_cno IS '首呼座席工号'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.first_call_cname IS '首呼座席姓名'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.first_call_qno IS '首呼队列号'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.first_call_qname IS '首呼队列名称'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.ivr_name IS 'IVR名称'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.hotline IS '热线号码'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.hotline_name IS '热线别名'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.xnumber IS '虚拟号码'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.ib_status IS '接听状态'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.ib_result IS '呼叫结果'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.status_robot IS '机器人接听状态'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.ib_tag IS '通话标签'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.webrtc_call_id IS 'WebRTCCallID'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.sip_cause_desc IS '呼叫情况'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.call_type IS '呼叫类型'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.record_file IS '录音文件'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.on_hook_source IS '挂断方'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.investigation_keys IS '满意度评价'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.agent_answer_in_time IS '首次及时应答'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.evaluation IS '是否邀评'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.user_field IS '自定义字段'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.start_time IS '开始时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.ring_time IS '振铃时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.ib_ringing_duration IS '振铃时长'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.end_time IS '结束时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.answer_time IS '接听时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.offhook_time IS '座席接起时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.bridge_time IS '首次接听时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.bridge_duration IS '通话时长'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.total_duration IS '总时长'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.first_join_queue_time IS '首次进入队列时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.say_voice_duration IS '语音播报时长'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.mark_data IS '备注'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.Etl_First_Dt IS '最初入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.Etl_Job IS '作业名称'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.Etl_Proc_Dt IS '本次入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.Etl_Tx_Dt IS '作业运行时间'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.Src_Sysname IS '来源系统'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.Src_Table IS '来源表'; 
 COMMENT ON COLUMN p20_pdm.t01_ccc_ib_record.Etl_Batch_No IS '作业批次号'; 

COMMENT ON TABLE p20_pdm.t01_ccc_ib_record IS 'smartccc呼入记录';