/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_ccc_ib_record(smartccc呼入记录)             */
/*Create Date:2024-07-19 14:31:48                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-07-19                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-07-19                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_ccc_ib_record                                                                   */
/*ETL Job Name:t01_ccc_ib_record                                                                   */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_ccc_ib_record_agi_CUR_I 
 ( LIKE :PDMDB.t01_ccc_ib_record)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_ccc_ib_record_agi_INS 
( LIKE :PDMDB.t01_ccc_ib_record)
ON COMMIT PRESERVE ROWS;

            
/*将不同数据插入到临时表                                                                           */
;INSERT INTO t01_ccc_ib_record_agi_INS (
         call_id                                                   /*CallID*/
        ,customer_number                                           /*客户号码*/
        ,customer_number_encrypt                                   /*客户号码加密串*/
        ,customer_province                                         /*客户省份*/
        ,customer_city                                             /*客户城市*/
        ,first_call_number                                         /*首呼座席电话*/
        ,first_call_cno                                            /*首呼座席工号*/
        ,first_call_cname                                          /*首呼座席姓名*/
        ,first_call_qno                                            /*首呼队列号*/
        ,first_call_qname                                          /*首呼队列名称*/
        ,ivr_name                                                  /*IVR名称*/
        ,hotline                                                   /*热线号码*/
        ,hotline_name                                              /*热线别名*/
        ,xnumber                                                   /*虚拟号码*/
        ,ib_status                                                 /*接听状态*/
        ,ib_result                                                 /*呼叫结果*/
        ,status_robot                                              /*机器人接听状态*/
        ,ib_tag                                                    /*通话标签*/
        ,webrtc_call_id                                            /*WebRTCCallID*/
        ,sip_cause_desc                                            /*呼叫情况*/
        ,call_type                                                 /*呼叫类型*/
        ,record_file                                               /*录音文件*/
        ,on_hook_source                                            /*挂断方*/
        ,investigation_keys                                        /*满意度评价*/
        ,agent_answer_in_time                                      /*首次及时应答*/
        ,evaluation                                                /*是否邀评*/
        ,user_field                                                /*自定义字段*/
        ,start_time                                                /*开始时间*/
        ,ring_time                                                 /*振铃时间*/
        ,ib_ringing_duration                                       /*振铃时长*/
        ,end_time                                                  /*结束时间*/
        ,answer_time                                               /*接听时间*/
        ,offhook_time                                              /*座席接起时间*/
        ,bridge_time                                               /*首次接听时间*/
        ,bridge_duration                                           /*通话时长*/
        ,total_duration                                            /*总时长*/
        ,first_join_queue_time                                     /*首次进入队列时间*/
        ,say_voice_duration                                        /*语音播报时长*/
        ,mark_data                                                 /*备注*/
        ,ib_unique_id                                              /*呼入通话ID*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        ,Etl_Batch_No                                              /*作业批次号*/
        
)
    SELECT
         P1.call_id                                                   /*CallID*/
        ,P1.customer_number                                           /*客户号码*/
        ,P1.customer_number_encrypt                                   /*客户号码加密串*/
        ,P1.customer_province                                         /*客户省份*/
        ,P1.customer_city                                             /*客户城市*/
        ,P1.first_call_number                                         /*首呼座席电话*/
        ,P1.first_call_cno                                            /*首呼座席工号*/
        ,P1.first_call_cname                                          /*首呼座席姓名*/
        ,P1.first_call_qno                                            /*首呼队列号*/
        ,P1.first_call_qname                                          /*首呼队列名称*/
        ,P1.ivr_name                                                  /*IVR名称*/
        ,P1.hotline                                                   /*热线号码*/
        ,P1.hotline_name                                              /*热线别名*/
        ,P1.xnumber                                                   /*虚拟号码*/
        ,P1.ib_status                                                 /*接听状态*/
        ,P1.ib_result                                                 /*呼叫结果*/
        ,P1.status_robot                                              /*机器人接听状态*/
        ,P1.ib_tag                                                    /*通话标签*/
        ,P1.webrtc_call_id                                            /*WebRTCCallID*/
        ,P1.sip_cause_desc                                            /*呼叫情况*/
        ,P1.call_type                                                 /*呼叫类型*/
        ,P1.record_file                                               /*录音文件*/
        ,P1.on_hook_source                                            /*挂断方*/
        ,P1.investigation_keys                                        /*满意度评价*/
        ,P1.agent_answer_in_time                                      /*首次及时应答*/
        ,P1.evaluation                                                /*是否邀评*/
        ,P1.user_field                                                /*自定义字段*/
        ,P1.start_time                                                /*开始时间*/
        ,P1.ring_time                                                 /*振铃时间*/
        ,P1.ib_ringing_duration                                       /*振铃时长*/
        ,P1.end_time                                                  /*结束时间*/
        ,P1.answer_time                                               /*接听时间*/
        ,P1.offhook_time                                              /*座席接起时间*/
        ,P1.bridge_time                                               /*首次接听时间*/
        ,P1.bridge_duration                                           /*通话时长*/
        ,P1.total_duration                                            /*总时长*/
        ,P1.first_join_queue_time                                     /*首次进入队列时间*/
        ,P1.say_voice_duration                                        /*语音播报时长*/
        ,P1.mark_data                                                 /*备注*/
        ,P1.ib_unique_id                                              /*呼入通话ID*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        
FROM t01_ccc_ib_record_agi_CUR_I P1
LEFT JOIN :PDMDB.t01_ccc_ib_record P2
ON    P1.call_id = P2.call_id
    AND P1.customer_number = P2.customer_number
    AND P1.customer_number_encrypt = P2.customer_number_encrypt
    AND P1.customer_province = P2.customer_province
    AND P1.customer_city = P2.customer_city
    AND P1.first_call_number = P2.first_call_number
    AND P1.first_call_cno = P2.first_call_cno
    AND P1.first_call_cname = P2.first_call_cname
    AND P1.first_call_qno = P2.first_call_qno
    AND P1.first_call_qname = P2.first_call_qname
    AND P1.ivr_name = P2.ivr_name
    AND P1.hotline = P2.hotline
    AND P1.hotline_name = P2.hotline_name
    AND P1.xnumber = P2.xnumber
    AND P1.ib_status = P2.ib_status
    AND P1.ib_result = P2.ib_result
    AND P1.status_robot = P2.status_robot
    AND P1.ib_tag = P2.ib_tag
    AND P1.webrtc_call_id = P2.webrtc_call_id
    AND P1.sip_cause_desc = P2.sip_cause_desc
    AND P1.call_type = P2.call_type
    AND P1.record_file = P2.record_file
    AND P1.on_hook_source = P2.on_hook_source
    AND P1.investigation_keys = P2.investigation_keys
    AND P1.agent_answer_in_time = P2.agent_answer_in_time
    AND P1.evaluation = P2.evaluation
    AND P1.user_field = P2.user_field
    AND P1.start_time = P2.start_time
    AND P1.ring_time = P2.ring_time
    AND P1.ib_ringing_duration = P2.ib_ringing_duration
    AND P1.end_time = P2.end_time
    AND P1.answer_time = P2.answer_time
    AND P1.offhook_time = P2.offhook_time
    AND P1.bridge_time = P2.bridge_time
    AND P1.bridge_duration = P2.bridge_duration
    AND P1.total_duration = P2.total_duration
    AND P1.first_join_queue_time = P2.first_join_queue_time
    AND P1.say_voice_duration = P2.say_voice_duration
    AND P1.mark_data = P2.mark_data
    AND P1.ib_unique_id = P2.ib_unique_id
    
WHERE  P2.call_id IS NULL
    OR P2.customer_number IS NULL
    OR P2.customer_number_encrypt IS NULL
    OR P2.customer_province IS NULL
    OR P2.customer_city IS NULL
    OR P2.first_call_number IS NULL
    OR P2.first_call_cno IS NULL
    OR P2.first_call_cname IS NULL
    OR P2.first_call_qno IS NULL
    OR P2.first_call_qname IS NULL
    OR P2.ivr_name IS NULL
    OR P2.hotline IS NULL
    OR P2.hotline_name IS NULL
    OR P2.xnumber IS NULL
    OR P2.ib_status IS NULL
    OR P2.ib_result IS NULL
    OR P2.status_robot IS NULL
    OR P2.ib_tag IS NULL
    OR P2.webrtc_call_id IS NULL
    OR P2.sip_cause_desc IS NULL
    OR P2.call_type IS NULL
    OR P2.record_file IS NULL
    OR P2.on_hook_source IS NULL
    OR P2.investigation_keys IS NULL
    OR P2.agent_answer_in_time IS NULL
    OR P2.evaluation IS NULL
    OR P2.user_field IS NULL
    OR P2.start_time IS NULL
    OR P2.ring_time IS NULL
    OR P2.ib_ringing_duration IS NULL
    OR P2.end_time IS NULL
    OR P2.answer_time IS NULL
    OR P2.offhook_time IS NULL
    OR P2.bridge_time IS NULL
    OR P2.bridge_duration IS NULL
    OR P2.total_duration IS NULL
    OR P2.first_join_queue_time IS NULL
    OR P2.say_voice_duration IS NULL
    OR P2.mark_data IS NULL
    OR P2.ib_unique_id IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :PDMDB.t01_ccc_ib_record (
         call_id                                                   /*CallID*/
        ,customer_number                                           /*客户号码*/
        ,customer_number_encrypt                                   /*客户号码加密串*/
        ,customer_province                                         /*客户省份*/
        ,customer_city                                             /*客户城市*/
        ,first_call_number                                         /*首呼座席电话*/
        ,first_call_cno                                            /*首呼座席工号*/
        ,first_call_cname                                          /*首呼座席姓名*/
        ,first_call_qno                                            /*首呼队列号*/
        ,first_call_qname                                          /*首呼队列名称*/
        ,ivr_name                                                  /*IVR名称*/
        ,hotline                                                   /*热线号码*/
        ,hotline_name                                              /*热线别名*/
        ,xnumber                                                   /*虚拟号码*/
        ,ib_status                                                 /*接听状态*/
        ,ib_result                                                 /*呼叫结果*/
        ,status_robot                                              /*机器人接听状态*/
        ,ib_tag                                                    /*通话标签*/
        ,webrtc_call_id                                            /*WebRTCCallID*/
        ,sip_cause_desc                                            /*呼叫情况*/
        ,call_type                                                 /*呼叫类型*/
        ,record_file                                               /*录音文件*/
        ,on_hook_source                                            /*挂断方*/
        ,investigation_keys                                        /*满意度评价*/
        ,agent_answer_in_time                                      /*首次及时应答*/
        ,evaluation                                                /*是否邀评*/
        ,user_field                                                /*自定义字段*/
        ,start_time                                                /*开始时间*/
        ,ring_time                                                 /*振铃时间*/
        ,ib_ringing_duration                                       /*振铃时长*/
        ,end_time                                                  /*结束时间*/
        ,answer_time                                               /*接听时间*/
        ,offhook_time                                              /*座席接起时间*/
        ,bridge_time                                               /*首次接听时间*/
        ,bridge_duration                                           /*通话时长*/
        ,total_duration                                            /*总时长*/
        ,first_join_queue_time                                     /*首次进入队列时间*/
        ,say_voice_duration                                        /*语音播报时长*/
        ,mark_data                                                 /*备注*/
        ,ib_unique_id                                              /*呼入通话ID*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        ,Etl_Batch_No                                              /*作业批次号*/
        
)
SELECT
         P1.call_id                                                   /*CallID*/
        ,P1.customer_number                                           /*客户号码*/
        ,P1.customer_number_encrypt                                   /*客户号码加密串*/
        ,P1.customer_province                                         /*客户省份*/
        ,P1.customer_city                                             /*客户城市*/
        ,P1.first_call_number                                         /*首呼座席电话*/
        ,P1.first_call_cno                                            /*首呼座席工号*/
        ,P1.first_call_cname                                          /*首呼座席姓名*/
        ,P1.first_call_qno                                            /*首呼队列号*/
        ,P1.first_call_qname                                          /*首呼队列名称*/
        ,P1.ivr_name                                                  /*IVR名称*/
        ,P1.hotline                                                   /*热线号码*/
        ,P1.hotline_name                                              /*热线别名*/
        ,P1.xnumber                                                   /*虚拟号码*/
        ,P1.ib_status                                                 /*接听状态*/
        ,P1.ib_result                                                 /*呼叫结果*/
        ,P1.status_robot                                              /*机器人接听状态*/
        ,P1.ib_tag                                                    /*通话标签*/
        ,P1.webrtc_call_id                                            /*WebRTCCallID*/
        ,P1.sip_cause_desc                                            /*呼叫情况*/
        ,P1.call_type                                                 /*呼叫类型*/
        ,P1.record_file                                               /*录音文件*/
        ,P1.on_hook_source                                            /*挂断方*/
        ,P1.investigation_keys                                        /*满意度评价*/
        ,P1.agent_answer_in_time                                      /*首次及时应答*/
        ,P1.evaluation                                                /*是否邀评*/
        ,P1.user_field                                                /*自定义字段*/
        ,P1.start_time                                                /*开始时间*/
        ,P1.ring_time                                                 /*振铃时间*/
        ,P1.ib_ringing_duration                                       /*振铃时长*/
        ,P1.end_time                                                  /*结束时间*/
        ,P1.answer_time                                               /*接听时间*/
        ,P1.offhook_time                                              /*座席接起时间*/
        ,P1.bridge_time                                               /*首次接听时间*/
        ,P1.bridge_duration                                           /*通话时长*/
        ,P1.total_duration                                            /*总时长*/
        ,P1.first_join_queue_time                                     /*首次进入队列时间*/
        ,P1.say_voice_duration                                        /*语音播报时长*/
        ,P1.mark_data                                                 /*备注*/
        ,P1.ib_unique_id                                              /*呼入通话ID*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        
FROM t01_ccc_ib_record_agi_INS P1
ON CONFLICT ( ib_unique_id)
DO UPDATE SET
     ib_unique_id=excluded.ib_unique_id
    ,call_id=excluded.call_id
    ,customer_number=excluded.customer_number
    ,customer_number_encrypt=excluded.customer_number_encrypt
    ,customer_province=excluded.customer_province
    ,customer_city=excluded.customer_city
    ,first_call_number=excluded.first_call_number
    ,first_call_cno=excluded.first_call_cno
    ,first_call_cname=excluded.first_call_cname
    ,first_call_qno=excluded.first_call_qno
    ,first_call_qname=excluded.first_call_qname
    ,ivr_name=excluded.ivr_name
    ,hotline=excluded.hotline
    ,hotline_name=excluded.hotline_name
    ,xnumber=excluded.xnumber
    ,ib_status=excluded.ib_status
    ,ib_result=excluded.ib_result
    ,status_robot=excluded.status_robot
    ,ib_tag=excluded.ib_tag
    ,webrtc_call_id=excluded.webrtc_call_id
    ,sip_cause_desc=excluded.sip_cause_desc
    ,call_type=excluded.call_type
    ,record_file=excluded.record_file
    ,on_hook_source=excluded.on_hook_source
    ,investigation_keys=excluded.investigation_keys
    ,agent_answer_in_time=excluded.agent_answer_in_time
    ,evaluation=excluded.evaluation
    ,user_field=excluded.user_field
    ,start_time=excluded.start_time
    ,ring_time=excluded.ring_time
    ,ib_ringing_duration=excluded.ib_ringing_duration
    ,end_time=excluded.end_time
    ,answer_time=excluded.answer_time
    ,offhook_time=excluded.offhook_time
    ,bridge_time=excluded.bridge_time
    ,bridge_duration=excluded.bridge_duration
    ,total_duration=excluded.total_duration
    ,first_join_queue_time=excluded.first_join_queue_time
    ,say_voice_duration=excluded.say_voice_duration
    ,mark_data=excluded.mark_data
    ,Etl_First_Dt=excluded.Etl_First_Dt
    ,Etl_Job=excluded.Etl_Job
    ,Etl_Proc_Dt=excluded.Etl_Proc_Dt
    ,Etl_Tx_Dt=excluded.Etl_Tx_Dt
    ,Src_Sysname=excluded.Src_Sysname
    ,Src_Table=excluded.Src_Table
    ,Etl_Batch_No=excluded.Etl_Batch_No
    

;
/*****程序结束退出                                               */
\q

