# coding: utf-8
import requests
import json
import psycopg2
import uuid
import datetime  
import time
import hashlib  
import time
import hmac  
import base64  
import urllib.parse  
import hashlib
from collections import OrderedDict  
from urllib.parse import quote_plus

#全局变量，便于参数使用的预设值 
current_date = datetime.date.today()     # 获取当前日期 
previous_date = current_date - datetime.timedelta(days=1)  # 获取前一天日期 
formatted_current_date = current_date.strftime("%Y-%m-%dT%H:%M:%SZ")  # 获取当前日期 - 标准化
formatted_previous_date = previous_date.strftime("%Y-%m-%dT%H:%M:%SZ")  # 获取前一天日期 - 标准化
timestamp = time.time()       #  为Unix time，即从"1970-01-01 00:00:00"至今的秒数；
sign_version = 'v2'     # 签名版本号，固定值v2
nonce = str(uuid.uuid4())
current_time_utc =( datetime.datetime.now() - datetime.timedelta(hours=8)).strftime("%Y-%m-%dT%H:%M:%SZ")

formatted2_current_date = current_date.strftime("%Y-%m-%d %H:%M:%S")  # 获取当前日期 - 标准化

def formatted2_previous_date(d):
    if d==0:
        return datetime.date.today().strftime("%Y%m%d")
    # 减去一个小时，得到前一个小时的开始时间  
    start_of_previous_date = datetime.date.today() - datetime.timedelta(days=d) 
    return start_of_previous_date.strftime("%Y%m%d")


def formatted2_previous_hour(h):
    if h==0:
        return datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
    start_of_current_hour = datetime.datetime.now().replace(minute=0, second=0, microsecond=0)  
    # 减去一个小时，得到前一个小时的开始时间  
    start_of_previous_hour = start_of_current_hour - datetime.timedelta(hours=h) 
    return start_of_previous_hour.strftime("%Y-%m-%d %H:%M:%S")

def previous_hour_timestamp(h):
    if h==0:
        return int(time.time())
    start_of_current_hour = datetime.datetime.now().replace(minute=0, second=0, microsecond=0)  
     # 减去一个小时，得到前一个小时的开始时间  
    start_of_previous_hour = start_of_current_hour - datetime.timedelta(hours=h) 
    return int(start_of_previous_hour.timestamp())
    
#计算签名
def generate_signature(str, private_key):
    signature = hmac.new(private_key.encode(), (str).encode(), hashlib.sha1)
    signature_b64 = base64.b64encode(signature.digest()).decode()
    return signature_b64

#构建查询链接
def build_query_string(params):  
    # 使用OrderedDict来保持排序  
    sorted_params = OrderedDict(sorted(params.items()))  
      
    # 拼接属性名和属性值，并使用&连接  
    query_string = '&'.join('{}={}'.format(  
        urllib.parse.quote_plus(k),   
        urllib.parse.quote_plus(str(v))  
    ) for k, v in sorted_params.items())        
    return query_string

def request_data_signature_get(scrollId):
    print(f'开始请求会话记录数据')
    url='https://api-bj.clink.cn/livechat/copy_chat_records'
    if scrollId is None:
      param={'Timestamp':current_time_utc,'Expires':86400,'date':formatted2_previous_date(0),'AccessKeyId':'b17759d3a36fba9a2cf522fbf4cbf177','limit':100}
      # param={'Timestamp':current_time_utc,'Expires':86400,'date':'20240801','AccessKeyId':'b17759d3a36fba9a2cf522fbf4cbf177','limit':100}
    else:
      param={'Timestamp':current_time_utc,'Expires':86400,'date':formatted2_previous_date(0),'AccessKeyId':'b17759d3a36fba9a2cf522fbf4cbf177','limit':100,'scrollId':scrollId}
      # param={'Timestamp':current_time_utc,'Expires':86400,'date':'20240801','AccessKeyId':'b17759d3a36fba9a2cf522fbf4cbf177','limit':100,'scrollId':scrollId}
    print(f'param: {param}')
    url_path = build_query_string(param)
    url_param = url_path
    print(f'url_param: {url_param}')
    url_param = f'GETapi-bj.clink.cn/livechat/copy_chat_records?{url_param}'
    print(f'待计算字符串: {url_param}')
    signature= generate_signature(url_param,'5g027B6w06630Y5240c1')
    print(f'计算签名: {signature}')
    print(f'编码后签名: {urllib.parse.quote_plus(signature)}')
    url = f'{url}?{url_path}&Signature={urllib.parse.quote_plus(signature)}'
    print(f'url: {url}')

    dataReqL=requests.get(url,headers={},params={})
    resText = dataReqL.text
    i = 0
    while 'error' in resText  and i < 5:
        print(f'请求会话记录失败，再次请求第{i+1}次')
        time.sleep(1)
        dataReqL=requests.get(url,headers={},params={})
        resText = dataReqL.text
        i = i + 1
    resD=json.loads(resText)
    print(dataReqL)
    return resD

def request_detail_signature_get(id):
    print(f'开始请求会话详情数据：{id}')
    url='https://api-bj.clink.cn/livechat/list_chat_messages'
    param={'Timestamp':current_time_utc,'Expires':86400,'mainUniqueId':id,'AccessKeyId':'b17759d3a36fba9a2cf522fbf4cbf177','limit':100}
    print(f'param: {param}')
    url_path = build_query_string(param)
    url_param = url_path
    print(f'url_param: {url_param}')
    url_param = f'GETapi-bj.clink.cn/livechat/list_chat_messages?{url_param}'
    print(f'待计算字符串: {url_param}')
    signature= generate_signature(url_param,'5g027B6w06630Y5240c1')
    print(f'计算签名: {signature}')
    print(f'编码后签名: {urllib.parse.quote_plus(signature)}')
    url = f'{url}?{url_path}&Signature={urllib.parse.quote_plus(signature)}'
    print(f'url: {url}')

    dataReqL=requests.get(url,headers={},params={})
    resText = dataReqL.text
    i = 0
    while 'error' in resText  and i < 5:
        print(f'请求会话详情失败，再次请求第{i+1}次')
        time.sleep(1)
        dataReqL=requests.get(url,headers={},params={})
        resText = dataReqL.text
        i = i + 1
    resD=json.loads(resText)
    if i==5 and 'error' in resText:
      print(f'请求会话详情失败，异常信息：{resD}')
    return resD



def load_data_to_db(dataList): 
    conn = psycopg2.connect(database="dataops_db", user="dbuser_dops", password="MIgTi3jA",host="172.17.0.8", port="5432")
    print('数据库连接成功')
    dataId=str(uuid.uuid4())
    total=len(dataList)
    print('临时id：'+dataId)
    json_object = json.dumps(dataList)
    cur=conn.cursor()
    sql="update data_api.api_data set is_loaded = '1' where api_id = 'f31fc54503de4ceda87ec9b3c99e4d0e';INSERT INTO data_api.api_data (id,api_id,data,total_num,is_loaded,status,request_tm,execute_tm,remark) values (%s,%s,%s,%s,'0','0',current_timestamp(0),current_timestamp(0),'')"
    cur.execute(sql,[dataId,'f31fc54503de4ceda87ec9b3c99e4d0e', json_object, total])
    conn.commit()
    cur.close()
    conn.close()
    print('加载数据结束：chat_records:查询会话记录列表')
    
def load_detail_data_to_db(ids, dataList): 
    conn = psycopg2.connect(database="dataops_db", user="dbuser_dops", password="MIgTi3jA",host="172.17.0.8", port="5432")
    print('数据库连接成功')
    dataId=str(uuid.uuid4())
    total=len(dataList)
    print('临时id：'+dataId)
    json_object = json.dumps(dataList)
    idstr = ','.join(ids)
    cur=conn.cursor()
    sql="update data_api.cc_details_ids_exp set is_loaded = '1' where api_id = '211b765fe3e04082a9f83a29e3b0c37c' and id in (%s);update data_api.cc_message_details set is_loaded = '1' where api_id = '211b765fe3e04082a9f83a29e3b0c37c'; INSERT INTO data_api.cc_message_details (id,api_id,data,total_num,is_loaded,status,request_tm,execute_tm,remark) values (%s,%s,%s,%s,'0','0',current_timestamp(0),current_timestamp(0),'')"
    cur.execute(sql,[idstr,dataId,'211b765fe3e04082a9f83a29e3b0c37c', json_object, total])
    conn.commit()
    cur.close()
    conn.close()
    print('加载数据结束：message_detail:获取会话详情')  
    
def load_detail_exp_to_db(id):
    try:
        print(f'添加消息异常记录:{id}')
        conn = psycopg2.connect(database="dataops_db", user="dbuser_dops", password="MIgTi3jA",host="172.17.0.8", port="5432")
        print('数据库连接成功')
        dataId=str(uuid.uuid4())
        print('临时id：'+dataId)
        cur=conn.cursor()
        sql=" INSERT INTO data_api.cc_details_ids_exp (id,api_id,is_loaded,status,request_tm,execute_tm,remark) values (%s,%s,'0','0',current_timestamp(0),current_timestamp(0),'')"
        cur.execute(sql,[id, '211b765fe3e04082a9f83a29e3b0c37c'])
        conn.commit()
        cur.close()
        conn.close()
        print(f'添加消息异常记录:{id} 结束')
    except Exception as e:  
        print(f'添加消息异常记录:{id}失败, 错误信息：{e}') 
  

if __name__ == "__main__":
    print(f'{formatted2_previous_hour(0)}开始请求会话信息')
    hour_delta = 1
    previous_time = previous_hour_timestamp(hour_delta)
    resL = request_data_signature_get(None)
    # print(resL)
    if 'error' in resL:
        error = resL['error']
        print(f'请求会话列表失败，失败原因：{error}')
    else:
        list = resL['records']
        scrollId = resL['scrollId']
        nextList = []
        i = 1
        while scrollId is not None:
            i = i+1
            resN = request_data_signature_get(scrollId)
            if 'error' in resN:
                error = resL['error']
                print(f'请求会话列表失败，失败原因：{error}')
                break
            nextList = resN['records']
            scrollId = resN['scrollId']
            if len(nextList) == 0:
                break
            list = list + nextList
            if len(nextList) < 100:
                break
        print(f'records会话记录数为：{len(list)}, 共请求{i}次会话')
        # load_data_to_db(list)
        detailDataList = []
        actList = []
        ids = []
        j = 0
        k = 0
        l = 0
        for data in list:
            try: 
                id = data['mainUniqueId']
                startTime = data['startTime']
                endTime = data['endTime']
                print(f'对比时间：{previous_time},数据开始时间：{startTime}，会话结束时间：{endTime}')
                if startTime < previous_time and endTime < previous_time:
                    print(f'该id不在采集{hour_delta}个小时内，不做采集{id}')
                    continue
                actList.append(data)
                j = j + 1
                print(f'{j}. 开始请求会话详情数据：{id}')
                resD = request_detail_signature_get(id)
                #print(f"请求工单详情结束")
                if 'records' in resD:
                    k = k + 1
                    ids.append(id)
                    dataList = resD['records']
                    # detailDataList.append(dataList)
                    detailDataList = detailDataList+dataList
                    print(f'{j}. deltail: {len(dataList)}')
                else:
                    l = l+1
                    error = resD['error']
                    print(f"请求会话详情（id:{id}）失败，错误信息：{error}")
                    load_detail_exp_to_db(id)
            except Exception as e:  
                print(f'请求会话详情（id:{id}）异常, ）异常信息：{e}')
                load_detail_exp_to_db(data['id'])
                print(f'{j}. exp end')
        print(f'实际加载{j}-{len(actList)}，{len(detailDataList)} - {k}-{l} 条记录')
        load_data_to_db(actList)
        if len(ids) > 0:
            ids_str = [str(item) for item in ids]
            # print(f'会话详情{ids_str}')
            load_detail_data_to_db(ids_str,detailDataList)
    print(f'{formatted2_previous_hour(0)}请求会话信息结束')  